// TP2_main.cpp: point d'entree de l'application
//	Demande à l'utilisateur d'entrer un certain nombre de division à effectuer. 
//Pour chaque division demande de saisir le dividente et le diviseur puis valide les nombres saisis 
//(entier non signé sur 16 bits; le diviseur doit etre differend de 0)
//Appelle la fonction division et écris le resultat dans un fichier. 

/*author
    Groupe 00
	- ASONMENE TEWOUNNO ROMUALD 	ASOR24338600
	- Moutcheu Wafo Handy Farex 	MOUH84310400
*/

#include<stdlib.h>
#include<stdio.h>
  
 unsigned int division(unsigned int x, unsigned int y);
 unsigned int validation(bool iszero);
 void viderBuffer();

int main() {

    unsigned int nbDiv, x, y, z, reste, i;
    unsigned short quotient;
    FILE * sortie = fopen("sortie.txt", "w");

    printf("Saisir le nombre de division a effectuer \n");
    scanf("%u", &nbDiv);
    viderBuffer();
    printf("Division du dividente x par le diviseur y : x / y \n");
    for (i = 1; i <= nbDiv; i++)
    {
        printf("Saisir le dividente x de la division %u \n", i);
        //validation de la saisie
        x = validation(true);
        printf("Saiair le diviseur y de la division %u \n", i);
        //validation de la saisie
        y = validation(false);
        z = division(x, y);
        quotient = (unsigned short) z;
        reste = (z>>16);
        fprintf(sortie, "La division numero %u : %u / %u = %d reste %u \n", i, x, y, quotient, reste);
        printf("La division numero %u : %u / %u = %d reste %u \n", i, x, y, quotient, reste);
    }
    
}

/* 
    fonction qui effectue la division de deux entier non signé 
    par restauration des restes partiels en utilisant que les opérations d'addition, de soustraction et de décalage.
    - paramètres passè par valeur : x unsigned int et y unsigned int
    - valeur de retour : x unsigned int
 */
unsigned int division(unsigned int x, unsigned int y) {
    y = (y<<16);
    for (int i = 0; i <= 15; i++)
    {
        x = (x<<1);
        if (x >= y) {
            x = x - y;
            x = x + 1;
        }
    }

    return x;
    
}

/* 
    fonction permettant la validation de la saisie des nombres entiers non signés compris entre 0 et 65535
    - paramètres : iszero de type booleen passè par valeur. permet d'autoriser ou non la valeur 0
    - valeur de retour : unsigned int nb
 */
unsigned int validation(bool iszero) {
    unsigned int nb;
    while (scanf("%u", &nb)!=1)
    {
        printf("Saisir un nombre entre 0 et 65535 \n");
        viderBuffer();
    }
    if (iszero)
    {
        while ((nb<0 || nb>65535))
        {
            printf("Saisir un nombre entre 0 et 65535 \n");
            if(scanf("%u", &nb)!=1) {
                viderBuffer();
                continue;
            }
        }
    }
    else
    {
        while ((nb<=0 || nb>65535))
        {
            printf("Saisir un nombre entre 1 et 65535 \n");
            if(scanf("%u", &nb)!=1) {
                viderBuffer();
                continue;
            }
        }
    }
    
    return nb;
    
}

/* 
    vide le buffer le l'entrée standard
 */
void viderBuffer() {
  int c;
  while((c=getchar()) != EOF && c != '\n' && c != '\r') {}
 
}