/**
@ Auteur: TASSEMBEDO Wendpuire Clover Océane
          François OBAM NSAH*/




#include <stdio.h>
#include <math.h>

void division_binaire(FILE* p,unsigned short* dividende,unsigned short* diviseur,unsigned short nbre_div);

unsigned short compteur_de_bit(int mon_nombre);


int main()
{
    printf("----------------------- Travail Pratique #2: Les dispositifs arithm%ctiques ----------------------- \n\n",130);

	FILE * pp = fopen("resultat_division.txt","w"); // Création du fichier resultat_division.txt en mode écriture
    if (pp == NULL) 
    { 
        printf("Impossible d'ouvrir le fichier"); 
        return 0; 
    } 

    unsigned short nbre_div;   // Variable permettant de sauvegarder le nombre de division demandé par l'utilisateur via la console
    nbre_div = 3;

    /* L'utilisateur rentre sur la console le nombre de division à effectuer */
    printf("Veuillez rentrer le nombre de division %c effectuer ",160);
    scanf("%hu",&nbre_div);

    printf("Le nombre de division %c effectuer est:  %hu \n",160,nbre_div);
    
    unsigned short dividende[nbre_div];   // Variable représentant les différents dividendes rentrés par l'utilisateur
    unsigned short diviseur[nbre_div];    // Variable représentant les différents diviseurs rentrés par l'utilisateur

    for(unsigned short i=0;i<nbre_div;i++)
    {
        printf("Veuillez rentrer le dividende de la Division %hu:",i+1);
        scanf("%hu",&dividende[i]);
        printf("Veuillez rentrer le diviseur de la Division %hu:",i+1);
        scanf("%hu",&diviseur[i]);
        while(diviseur[i] == 0)
        {
            printf("Le divieur doit %ctre compris entre 1 et 65535,veuillez rentrer de nouveau le diviseur de la Division %hu: ",136,i+1);
            scanf("%hu",&diviseur[i]);
        }
        printf("\n------------------------------------------------------- \n");

    }

    pp = fopen("resultat_division.txt","a+");

    /* ------------------- Division binaire ------------------- */
    division_binaire(pp,dividende,diviseur,nbre_div);

    fclose(pp);
    
    return 1;
}

/* Cette fonction permet d'effectuer la division de nombres entiers positifs de 16 Bits par la
 * méthode de restauration des restes parties.
 * @Paramètres:
 *              INPUT: unsigned short* dividende =  tableau contenant tous les dividendes de division fournit par l'utilisateur
 *                     unsigned short* diviseur =  tableau contenant tous les diviseurs de division fournit par l'utilisateur
 *                     unsigned short nbre_div =  nombre de division à effectuer
 *                     FILE* p = fichier dans lequel les résultats des différentes divisions seront sauvegardées
 * 
 *              OUTPUT: FILE* p = fichier dans lequel les résultats des différentes divisions seront sauvegardées
*/

void division_binaire(FILE* p,unsigned short* dividende,unsigned short* diviseur,unsigned short nbre_div)
{
    unsigned short reste = 0;           // Reste de la division entre le dividende et le diviseur
    unsigned short _dividende;          // Initialisation du dividende dans une nouvelle variable afin d'éviter de l'affecter durnat la sauvegarde dans le fichier
    unsigned short _diviseur;           // Initialisation du diviseur dans une nouvelle variable afin d'éviter de l'affecter durnat la sauvegarde dans le fichier
    
    /* Création d'une entête dans le fichier */
    fprintf(p,"---------------------- DIVISION BINAIRE ---------------------- \n");

    // Cette boucle permet de calculer toutes les divisions rentrer par l'utilisateur
    for (unsigned short i=0;i<nbre_div;i++)
    {
        _dividende = dividende[i];
        _diviseur = diviseur[i];

        // Étant donné que nous somme sur 16 bits, l'itération maximale sera 15  ou à ne pas franchir est 16.
        for(unsigned short j=0;j<16;j++)
        {
            // Étape 1: Décallage à gauche du reste et du dividende
            int RESTEnDIVIDENDE = (reste<<16) + _dividende;
            RESTEnDIVIDENDE <<=1;

            reste = (RESTEnDIVIDENDE>>16) & 0xFFFF;   //0xFF
            _dividende = RESTEnDIVIDENDE & 0xFFFF;

            // Étape 2: On soustrait le diviseur du reste, le resultat est ensuite affecté au reste
            reste -= _diviseur;

           // Étape 3: On vérifie le bit le plus signifiant du reste, si c'est 0, on met le bit le moins signifiant du dividende à 1 et sinon on le met à 0

           if(reste &(1<<15))
           {
            _dividende &= ~1;

            // On effectue la restoration du reste
            reste += _diviseur;
           }
           else{
            _dividende |= 1; 
           }

        }
        // printf("Division %u: %hu / %hu = %hu reste %hu \n",(i+1),dividende[i],diviseur[i],_dividende,reste);  // Décommenter pour un affiche direct dans la console
        fprintf(p, "Division %u: %hu / %hu = %hu reste %hu \n",(i+1),dividende[i],diviseur[i],_dividende,reste);
        reste = 0; // Ceci permet de réinitialiser le calcul pour la prochaine division

    }
}
