/* NOM: Fouejio Nguekeng Lislaure
* CODE PERMANENT: 68310300
* FONCTION: division()
* DESCRIPTION: fonction pour effectuer la division de nombres entiers positif de 16 bits en utilisant la methode de division binaire par restauration des restes partiel
* INPUT: -dividende(entier positif de 16 bits representant le nombre   diviser)
* -diviseur(entier positif de 16 bits representant le nombre qui divise)
* OUTPUT: reste-quotient(entier positif 16 bits representant le reste de la division et le resultat de la division
*/

#include <stdio.h>

int main()
{
	
    int n, i, j, dividende, diviseur, quotient, reste;
    FILE *fp;
    
    //Ouvrir le fichier texte pour ecrire les resultats
    
    fp = fopen("resultats.txt", "w");
    
    //Demander   l'utilisateur le nombre de divisions

    printf("Entrez le nombre de divisions  effectuer : ");
    scanf("%d", &n);

//Boucle for pour effectuer chaque divisions

    for (i = 1; i <= n; i++)
    {
    	//Demander  l'utilisateur le dividende et le diviseur pour chaque division
    	
        printf("Entrez le dividende (entre 0 et 65535) : ");
        scanf("%d", &dividende);

        printf("Entrez le diviseur (entre 1 et 65535) : ");
        scanf("%d", &diviseur);

        quotient = 0;
        reste = 0;

//Boucle for pour la division binaire par restauration des restes partiels

        for (j = 15; j >= 0; j--)
        {
            reste = reste << 1;
            reste = reste | (dividende >> j & 1);

            if (reste >= diviseur)
            {
                reste = reste - diviseur;
                quotient = quotient | (1 << j);
            }
        }
        
// Ecrire le resultat dans le fichier texte

        fprintf(fp, "Division %d: %d / %d = %d reste %d\n", i, dividende, diviseur, quotient, reste);
        printf("le resultat a t? enregistr dans un fichier texte\"resultats.txt\".\n");
    }

    fclose(fp);

    return 0;
}
