#include <stdio.h>
/*Auteurs: Traore Kiswendsida Samir- Code permanent (TRAK69360400)- Groupe 00
*          ZAOULI BI YOUAN OLIVIER- Code permanent (ZAOB07268300)- GROUPE 01
*          TCHAMBA TCHANGA Hervera Louetta- Code permanent (TCHH70270400)- GROUPE 01
*          N'Guessan Marc-Elie- Code permanent (NGUM91280600)- GROUPE 01
*      TP-2-Architecture des ordinateurs
*
*    criture d'un programme en langage C qui effectue la division de nombres entiers positifs de 16 bits.
*/

// Fonction permettant d'ffectuer les dividions et de retourner le reste et le quotient

unsigned long division(unsigned short dividende, unsigned short diviseur) {
    unsigned short quotient = 0;
    unsigned short reste = 0;
    int i;

    for (i = 15; i >= 0; i--) {
        reste <<= 1;
        reste |= (dividende >> i) & 1;

        if (reste >= diviseur) {
            reste -= diviseur;
            quotient |= 1UL << i;
        }
    }

    return (unsigned long)reste << 16 | quotient;
}

int main() {
    int nbDivisions, i;
    unsigned short dividende, diviseur;
    FILE* file = fopen("resultats.txt", "w");

    printf("Entrez le nombre de divisions a effectuer: ");
    scanf("%d", &nbDivisions);

    for (i = 1; i <= nbDivisions; i++) {
        printf("Entrez le dividende et le diviseur pour la division %d: ", i);
        scanf("%hu %hu", &dividende, &diviseur);

        unsigned long resultat = division(dividende, diviseur);
        unsigned short quotient = resultat & 0xFFFF;
        unsigned short reste = resultat >> 16;

        // criture du rsultat dans le fichier

        fprintf(file, "Division %d: %hu / %hu = %hu reste %hu\n", i, dividende, diviseur, quotient, reste);
    }

    fclose(file); // Fermeture du fichier

    return 0;
}
