

/* Nom: Salifou
   Prenom: Zeinab
   Code Permanent: SALZ22339800*/

#include <stdio.h>
#include <stdlib.h>


unsigned int division(unsigned int dividende, unsigned int diviseur);
/*
fonction main: Fonction d'entre qui permet qui permet a l'utilisateur de rentrer le nombre de divisions aeffectuer
et les valeurs du dividende et du diviseur a travers scanf.
les resultats des divisions sont ecrits dans le fichier reponse.txt
*/

void main() {


    unsigned int i, dividende, diviseur, reste, nombreDeDivisions;
    unsigned short quotient;
    FILE* rep;


    // Nom et mode d'ouverture du fichier texte
    rep = fopen("reponse.txt", "w");

    printf("Entrez le nombre de divisions a effectuer : ");

    // Format de l'objet lu et pointeur sur l'objet en memoire
    scanf("%i", &nombreDeDivisions);
    printf("Entrez la ou les divisions a effectuer de la facon suivante : a/b\n");



    for (i = 1; i <= nombreDeDivisions; i++) {

        // Il suffira d'entrer a/b
        scanf("%i/%i", &dividende, &diviseur);


        // Boucle pour valider les valeurs du diviseur et du dividende, pour qu'ils soient dans l'intervalle de validation
        while (dividende < 0 || dividende > 65535 || diviseur <= 0 || diviseur > 65535) {
            printf("Division invalide, Veuillez entrer la ou les divions a effectuer svp.\n");
            scanf("%i/%i", &dividende, &diviseur);
        }

        // La division de a par b
        reste = division(dividende, diviseur);

        // Les 16 premiers bits
        quotient = unsigned short(reste);

        // Les 16 derniers bits
        reste = (reste >> 16);

        // Affichage du pointeur du fichier de destination, du format d'affichage des objets et de la liste des objets ecrits
        fprintf(rep, "Division %i: %i/%i = %d reste %i\n", i, dividende, diviseur, quotient, reste);

    }

    fclose(rep); /* fermeture du fichier */

}
/*
fonction division: fait une division binaire par restauration des restes partiels
(nombres entiers positifs de 16bits)
Parametres:
- dividende
- diviseur
La fonction retourne un entier(int)
*/

unsigned int division(unsigned int dividende, unsigned int diviseur) {

    int i;
    diviseur = diviseur << 16;
    for (i = 0; i < 16; i++) {
        dividende = dividende << 1;
        if (dividende >= diviseur) {
            dividende = dividende - diviseur;
            dividende = dividende + 1;
        }
    }
    // Quotient: 16 bits le moins significatif et reste 16 bits le plus significatif
    return dividende;
}