#include <stdio.h>

// Fonction de division binaire par restauration des restes partiels
unsigned short division(unsigned short dividende, unsigned short diviseur) {
  // Initialisation des variables
  unsigned short quotient = 0;
  unsigned short reste = dividende;

  // Boucle de division
  while (reste >= diviseur) {
    // Incrmentation du quotient
    quotient++;

    // Soustraction du diviseur du reste
    reste -= diviseur;

    // Dcalage  droite du reste
    reste >>= 1;
  }

  // Retour du quotient et du reste
  return (quotient << 16) | reste;
}

int main() {
  // Initialisation des variables
  unsigned short dividende, diviseur;
  int nombre_divisions;

  // Saisie du nombre de divisions
  printf("Combien de divisions souhaitez-vous effectuer ? ");
  scanf("%d", &nombre_divisions);

  // Boucle de traitement des divisions
  for (int i = 0; i < nombre_divisions; i++) {
    // Saisie du dividende et du diviseur
    printf("Divisende (entre 0 et 65535) : ");
    scanf("%hu", &dividende);
    printf("Diviseur (entre 1 et 65535) : ");
    scanf("%hu", &diviseur);

    // Calcul du quotient et du reste
    unsigned short quotient_reste = division(dividende, diviseur);

    // Affichage des rsultats
    printf("Division %d: %hu / %hu = %hu reste %hu\n", i + 1, dividende, diviseur, quotient_reste >> 16, quotient_reste & 0xFFFF);
  }

  return 0;
}
