/*Groupe de 2 étudiants
  NOM COMPLET (1): TCHOUTANG YI TCHUIGOUA LYBLASSA ARCHANGE; code permanent:TCHL82330400; 
  NOM COMPLET (2): ROUSELLE SANDRA BOBDA MASSU. Code permanent: BOBR14039900;

Ce programme effectue la division binaire par restauration des restes partiels sur des nombres
entiers positifs de 16 bits. L'utilisateur entre le nombre de divisions à effectuer, ainsi que
les paires de valeurs a/b pour chaque division. Les résultats (quotient et reste) sont enregistrés
dans le fichier "reponse.txt".
*/


#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <stdio.h>

// Fonction de division binaire par restauration des restes partiels
unsigned int division(unsigned int a, unsigned int b);

int main() {
    unsigned int i, a, b, d, N;
    unsigned short c;
    FILE* rep; // Utilisation de FILE*

    // Ouverture du fichier en mode écriture
    rep = fopen("reponse.txt", "w");

    // Saisie du nombre de divisions à effectuer
    printf("Entrer le nombre de division a effectuer\n");
    scanf("%i", &N);

    // Saisie des divisions
    printf("Entrer la ou les divisions a effectuer\n");
    printf("de la facon suivante: a/b\n");

    for (i = 1; i <= N; i++) {
        scanf("%i/%i", &a, &b);     /* il suffira d'entrer a/b */
        d = division(a, b);         /* division de a par b */
        c = (unsigned short)d;      /* les 16 premiers bits */
        d = (d >> 16);              /* les 16 derniers bits */

        // Écriture dans le fichier reponse.txt
        fprintf(rep, "Division %i: %i/%i =  %d reste %i\n", i, a, b, c, d);
    }

    // Fermeture du fichier
    fclose(rep);

    // Informer l'utilisateur de vérifier le fichier reponse.txt
    printf("Les resultats sont enregistres dans le fichier reponse.txt\n");

    return 0; // Fin du programme sans erreur
}

unsigned int division(unsigned int a, unsigned int b) {
    // Décalage de b de 16 bits à gauche (b = b << 16)
    b = b << 16;

    // Boucle de 16 itérations pour chaque bit
    for (int i = 0; i < 16; i++) {
        // Décalage de a de 1 bit à gauche
        a = a << 1;

        // Si a est plus grand ou égal à b, on soustrait et on incrémente
        if (a >= b) {
            a = a - b;
            a = a + 1;
        }
    }

    
    return a; /* Quotient: 16 BLMS reste 16 BLPS*/
}