/*
    Travail Pratique #2

    par: 
            Amélie CANTIN  CANA17527607
            Soukaina QARAQOUNA  QARS19309000
            Assia RABAHI  RABA78260300

            Groupe 00 (mardi)

    21-11-2023
*/

# include <stdio.h>

// Déclaration des fonctions
unsigned int division(unsigned int a, unsigned int b);


/*
    Fonction principale qui effectue la division de nombres entiers positifs de 16 bits
*/
int main() {
    unsigned int i, a, b, d; 
    // où i = indice de boucle, a = dividende, b = diviseur, d = division
    // variables de type int => taille de 32 bits
    unsigned short c;  // c = quotient (short int => sa taille est de 16 bits)
    int n;  // n = nombre de divisions à effectuer  
    
    FILE * rep;
    rep = fopen("reponse.txt", "w"); // ouverture du fichier
    
    printf("Entrer le nombre de divisions a effectuer:\n");
    scanf("%i", &n);
    // Validation du nombre n entré:
    while (!(n > 0)) {
        printf("Le nombre de divisions doit etre superieur a 0. Recommencer: \n");
        scanf("%i", &n);
        if (n > 0) {
            break;
        }
        /*
        else {
            printf("Le nombre de divisions doit etre superieur a 0. Recommencer: \n");
        } */
    }

    printf("Entrer la ou les divisions a effectuer\n");
    printf("de la facon suivante: a/b\n"); 
    for (i = 1; i <= n; i++) {
        scanf("%i / %i", &a, &b);   //Entrer a/b 
        unsigned int max = 65535;
        unsigned int min = 1;
        // Validation des valeurs de a et b entrées:
        while (((a < min) || (a > max)) || ((b < min) || (b > max))) {
            printf("Les nombres doivent etre entre 1 et 65535: ");
            scanf("%i / %i", &a, &b);
            if (((a >= min) && (a <= max)) && (( b>= min) && (b <= max))) {
            break;
            }
            else {
                printf("Entree invalide. Recommencer. \n");  //Nb invalide
            }
        }   

    d = division(a,b);          //La division de a par b par la fonction division()
    c = (unsigned short) (d);     // Les 16 premiers bits (quotient) vont dans la variable c
    d = (d>>16);                //Les 16 derniers bits sont décalés vers la droite (reste)
    fprintf(rep, "Division %i: \t%i/%i = %d,\t reste %i\n", i,a,b,c,d);
    }

    printf("Consulter le fichier reponse.txt pour connaitre les reponses !");
    fclose(rep); // fermeture du fichier
}


/*
    Fonction division():
    Fonction qui effectue la division de nombres entiers positifs de 16 bits
    selon la méthode de division binaire par restauration des restes partiels 
    (en utilisant les opérations d'addition, de soustraction et de décalage)
*/
unsigned int division(unsigned int a, unsigned int b) {
    
    b = b << 16;  // Décalage de b de 16 bits à gauche

    // Boucle de 16 itérations (1 itération par bit du nombre de 16 bits):
    for (int i = 0; i < 16; i++) {
        
        a = a << 1;  // Décalage de a de 1 bit à gauche

        // Vérification si a est supérieur ou égal à b:
        if (a >= b) {   // dividende >= diviseur
            a = a - b;  // Soustraction de b de a
            a = a + 1;  // Ajout de 1 au résultat (quotient)
        }
    }
    return a; // La variable a (de type unsigned int) a 32 bits: Quotient = 16 BLMS, Reste = 16 BLPS
}
